<template>
  <ele-modal
    custom-class="ele-dialog-form long-dialog-form"
    :centered="true"
    v-if="visible"
    :visible.sync="visible"
    :title="title"
    :close-on-click-modal="false"
    width="70%"
    @close="cancel"
  >
    <el-form ref="form" :model="form" :rules="rules" class="el-form-box" label-width="120px">
      <headerTitle title="发货信息"></headerTitle>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item
            label="销售订单"
            prop="orderNo"

          >
            <el-input
              clearable
              v-model="form.orderNo"
              @click.native="handleOrderBtn"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="受托收货单"

          >
            <el-input
              clearable
              v-model="form.entrustedCode"
              @click.native="handleEntrustedReceive"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item
            label="客户名称"
            prop="contactName"
            >
            <el-input v-model="form.contactName" disabled></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="客户联系人"
            prop="linkName"
            >
            <el-input clearable v-model="form.linkName" placeholder="请输入"/>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item
            label="计价方式"
            >
            <el-select v-model="form.pricingWay" disabled style="width: 100%">
              <el-option label="按数量计费" :value="1"></el-option>
              <el-option label="按重量计费" :value="2"></el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="客户电话"
            prop="linkPhone"
            >
            <el-input clearable v-model="form.linkPhone" placeholder="请输入"/>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item label="车辆号" prop="carNo" >
            <el-input clearable v-model="form.carNo" placeholder="请输入"/>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="收货地址"
            prop="receiveAddress"
            >
            <el-input
              clearable
              v-model="form.receiveAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item prop="sendFiles" label="发货附件">
            <fileUpload
              v-model="form.sendFiles"
              module="main"
              :showLib="false"
              :limit="10"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item prop="repliedFiles" label="回执附件">
            <fileUpload
              v-model="form.repliedFiles"
              module="main"
              :showLib="false"
              :limit="10"/>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <headerTitle title="产品清单" style="margin-top: 30px"></headerTitle>
    <inventoryTable
      :pricingWay="form.pricingWay"
      :entrustedCode="form.entrustedCode"
      ref="inventoryTableref"
      :orderId="form.orderId"
    ></inventoryTable>

    <div slot="footer" class="footer">
      <el-button type="primary" @click="save">保存</el-button>
      <el-button type="primary" @click="save('sub')">提交</el-button>

      <el-button @click="cancel">返回</el-button>
    </div>
    <orderListDialog
      ref="orderListDialogRef"
      @changeParent="changeOrder"
    ></orderListDialog>
    <!--  受托发货单  -->
    <entrusted-receive-dialog :entrusted-receive-dialog-flag.sync="entrustedReceiveDialogFlag"
                              v-if="entrustedReceiveDialogFlag"
                              @changeParent="getInfo"
                              ref="entrustedReceiveDialogRef"></entrusted-receive-dialog>
  </ele-modal>
</template>

<script>
import {acceptUnpackoptions} from '@/enum/dict';
import fileUpload from '@/components/upload/fileUpload';
import dictMixins from '@/mixins/dictMixins';
import parentList from '@/views/saleManage/contact/components/parentList.vue';
import {getSaleOrderDetail} from '@/api/saleManage/saleorder';
import {
  addSendInformation,
  UpdateSendInformation,
  getSendSaleOrderrecordDetail,
  submit
} from '@/api/saleManage/saleordersendrecord';
import {

  getPSaleEntrustedReceiveDetailAPI,
} from "@/api/saleManage/entrustedReceive";
import {getcontactlink} from '@/api/saleManage/businessFollow';
import inventoryTable from './inventoryTable.vue';
import orderListDialog from './orderListDialog.vue';
import {copyObj} from '@/utils/util';
import entrustedReceiveDialog from './entrustedReceiveDialog.vue'
import outSourceSendDialog from "@/views/purchasingManage/purchaseOrder/invoice/components/outSourceSendDialog.vue";

export default {
  mixins: [dictMixins],
  components: {
    outSourceSendDialog,
    fileUpload,
    inventoryTable,
    orderListDialog,
    parentList,
    entrustedReceiveDialog
  },
  data() {
    let formDef = {
      id: '',
      contactId: '',
      contactName: '',
      entrustedCode: '',
      entrustedId: '',
      pricingWay: 1,
      sendFiles: [],
      repliedFiles: [],

      receiveAddress: '',
      carNo: '',
      carId: '',
      linkName: '',
      linkPhone: '',
      orderNo: '',
      orderId: '',
      replied: 0
    };

    return {
      detailData: {},
      payWayOptions: [],
      delDetailIds: [],
      linkNameOptions: [],
      acceptUnpackoptions,
      visible: false,
      entrustedReceiveDialogFlag: false,
      title: '',
      row: {},
      activeName: 'base',
      formDef,
      form: copyObj(formDef),
      tableBankData: [],
      tableLinkData: [],
      // 组织机构树形结构数据
      groupTreeData: [],
      groupData: [],
      rules: {
        partaName: [
          {required: true, message: '请选择客户名称', trigger: 'change'}
        ],
        linkName: [
          {required: true, message: '请输入', trigger: ['blur', 'change']}
        ],
        orderNo: [
          {required: true, message: '请选择', trigger: 'change'}
        ],
        receiveAddress: [
          {required: true, message: '请输入', trigger: 'change'}
        ],
      },

      // 提交状态
      loading: false,
      // 是否是修改
      isUpdate: false,
      businessId: ''
    };
  },
  computed: {
    allcountAmount() {
      return this.$store.state.order.allcountAmount;
    }
  },

  methods: {
    //选择订单回调
    changeOrder(obj) {
      this.form = Object.assign({}, this.form, {
        orderId: obj.id,
        orderNo: obj.orderNo
      });
      this.getSaleOrderDetail(obj.id);
    },
    //获取订单详情
    async getSaleOrderDetail(id) {
      this.loading = true;
      const data = await getSaleOrderDetail(id);
      this.loading = false;
      if (data) {
        this.$nextTick(() => {
          let {
            partaId,
            partaName,
            partaTel,
            orderNo,
            id,
            partaLinkName,
            receiveAddress,
            productList,
            totalAmount,
            payAmount
          } = data;
          if (productList && productList.length > 0) {
            productList.forEach((v) => {
              v.orderTotalCount = v.totalCount;
            });
          }
          this.form = Object.assign({}, this.form, {
            contactId: partaId,
            contactName: partaName,
            linkName: partaLinkName,
            linkPhone: partaTel,
            orderNo,
            orderId: id,
            receiveAddress,
            productList,
            totalAmount,
            payAmount
          });
          this.$refs.inventoryTableref &&
          this.$refs.inventoryTableref.putTableValue(productList);
        });
      }
    },

    //发货单详情
    async getSendSaleOrderDetail(id) {
      this.businessId = id;

      this.loading = true;
      const data = await getSendSaleOrderrecordDetail(id);
      console.log(11111);
      this.loading = false;
      if (data) {
        this.$nextTick(() => {
          this.form = data;
          this.form.pricingWay = data?.saleOrder?.pricingWay
          this.$refs.inventoryTableref &&
          this.$refs.inventoryTableref.putTableValue(data.productList);
        });
      }
    },
    //选择受托收货单弹框
    handleEntrustedReceive(e) {
      if (e.target.nodeName == 'I') {
        this.form = Object.assign({}, this.form, {
          carNo: '',
          carId: '',
          linkName: '',
          linkPhone: '',
          orderNo: '',
          orderId: '',
          contactId: '',
          contactName: '',
          entrustedCode: '',
          entrustedId: '',
          sendNoteNo: '',
          pricingWay: '',
        })
        this.$refs.inventoryTableref &&
        this.$refs.inventoryTableref.putTableValue([]);
        return
      }
      this.searchParams = {
        orderId: this.form.orderId
      }
      this.entrustedReceiveDialogFlag = true
      this.$nextTick(() => {
        this.$refs.entrustedReceiveDialogRef.init();
      })

    },
    //获取受托收货单数据回调
    async getInfo(row) {
      const data = await getPSaleEntrustedReceiveDetailAPI(row.id);
      this.$nextTick(() => {
        let {
          carNo,
          carId,
          code,
          id,
          linkName,
          linkPhone,
          orderId,
          orderNo,
          productList,
          contactId,
          contactName,
          pricingWay = data?.saleOrder?.pricingWay
        } = data;
        if (productList && productList.length > 0) {
          productList.forEach((v) => {
            v.orderTotalCount = v.orderTotalCount || v.totalCount;
          });
        }
        this.form = Object.assign({}, this.form, {
          contactId,
          contactName,
          linkName,
          linkPhone,
          orderNo,
          orderId,
          productList,
          carNo,
          carId,
          pricingWay,
          entrustedCode: code,
          entrustedId: id
        });
        productList.forEach(item => {
          item.id = ''
        })
        this.$refs.inventoryTableref &&
        this.$refs.inventoryTableref.putTableValue(productList, code);
      });
    },

    //更新联系人数据
    async getLinkInfo(contactId) {
      const data = await getcontactlink({contactId});
      if (data && data?.length) {
        this.linkNameOptions = data;
      }
    },
    selectFocus() {
      if (this.linkNameOptions.length === 0) {
        return this.$message.error('请先选择名称');
      }
    },

    handHead() {
      let item = {
        id: this.form.partbLinkId
      };
      this.$refs.headRef.open(item);
    },

    //选择订单弹框
    handleOrderBtn(e) {
      if (e.target.nodeName == 'I') {
        this.form = Object.assign({}, this.form, {
          contactId: '',
          contactName: '',
          carNo: '',
          carId: '',
          linkName: '',
          linkPhone: '',
          orderNo: '',
          orderId: '',
          pricingWay: '',
          entrustedCode: '',
          entrustedId: '',
        })
        this.$refs.inventoryTableref &&
        this.$refs.inventoryTableref.putTableValue([]);
        return
      }
      let item = {
        id: this.form.orderId
      };
      this.$refs.orderListDialogRef.open(item);
    },

    //打开新增编辑弹框
    async open(type, row, orderId) {
      this.title = type === 'add' ? '新增发货单' : '修改';
      this.row = row;
      this.visible = true;

      if (orderId) {
        await this.getSaleOrderDetail(orderId);
      }
      if (row && row?.id) {
        await this.getSendSaleOrderDetail(row?.id);
      }

      if (type == 'add') {
        this.isUpdate = false;
      } else {
        this.isUpdate = true;
      }
    },
    entrustedReceiveInit(row) {
      this.title = '新增发货单'
      this.visible = true;
      this.isUpdate = false;
      this.getInfo(row);
    },

    salesmanChange(val, info) {
      this.otherForm.salesmanName = info.name;
    },
    settlementModeChange(info) {
      this.form.settlementModeName = info.dictValue;
    },
    ifChiefChange(value, idx) {
      if (value === 1) {
        this.tableLinkData.forEach((e) => (e.ifChief = 0));
        this.tableLinkData[idx].ifChief = 1;
      }
    },

    getValidate() {
      return Promise.all([
        new Promise((resolve, reject) => {
          this.$refs.form.validate((valid) => {
            if (!valid) {
              reject(false);
            } else {
              resolve(true);
            }
          });
        }),
        new Promise((resolve, reject) => {
          this.$refs.inventoryTableref.validateForm((valid) => {
            if (!valid) {
              reject(false);
            } else {
              resolve(true);
            }
          });
        })
      ]);
    },
    async save(type) {
      try {
        await this.getValidate();
        // 表单验证通过，执行保存操作
        this.loading = true;

        if (!this.isUpdate) {
          delete this.form.id;
        }
        this.form.repliedFiles = this.form.repliedFiles || [];


        this.form.replied = this.form.repliedFiles.length > 0 ? 1 : 0;
        let commitData = Object.assign({}, this.form, {
          productList: this.$refs.inventoryTableref.getTableValue()
        });

        if (this.isUpdate) {
          UpdateSendInformation(commitData)
            .then((res) => {
              this.loading = false;
              this.$message.success('修改成功');
              if (type === 'sub') {
                this.sendSubmit(res);
                return;
              }
              this.cancel();
              this.$emit('done');
            })
            .catch((e) => {
              //this.loading = false;
            });
        } else {
          addSendInformation(commitData)
            .then((res) => {
              this.loading = false;
              this.$message.success('新增成功');
              if (type === 'sub') {
                this.sendSubmit(res);
                return;
              }
              this.cancel();
              this.$emit('done');
            })
            .catch((e) => {
              //this.loading = false;
            });
        }
      } catch (error) {
        console.log(error);
        // 表单验证未通过，不执行保存操作
      }
    },
    sendSubmit(res) {
      submit({
        businessId: this.businessId || res
        // productionSupervisorId
      }).then((res) => {
        this.cancel();
        this.$emit('done');
      });
    },
    cancel() {
      this.$nextTick(() => {
        this.activeName = 'base';
        // 关闭后，销毁所有的表单数据
        this.$refs['otherForm'] && this.$refs['otherForm'].resetFields();
        this.$refs['formRef'] && this.$refs['formRef'].resetFields();
        this.$store.commit('order/clearUserData');
        this.form = copyObj(this.formDef);
        this.visible = false;
      });
    }
  }
};
</script>
<style scoped lang="scss">
.TotalAmount {
  font-size: 16px;
  padding-right: 30px;
}

.headbox {
  display: flex;
  justify-content: flex-start;
  align-items: center;

  .amount {
    font-size: 14px;
    font-weight: bold;
    margin-right: 20px;
  }
}
</style>
